//Software base para OPS012
//Controlador ESP32

//Biblioteca para temperatura/carga
#include <HX711_ADC.h>

//Definição dos pinos do controlador
//Saidas digiais
#define pin_Y1 13
#define pin_Y2 12
#define pin_Y3 27
#define pin_Y4 26
#define pin_Y5 25
#define pin_Y6 33

//Entradas digitais
#define pin_X1 15
#define pin_X2 14
#define pin_X3 39
#define pin_X4 36

//Entradas analógicas
#define AV3 35
#define AV4 34

//Saidas analogicas
#define AO1 32
#define AO2 23

//Pinos auxiliares
#define ENTX_pin 2 //Pino de comunicação RS485

//Entradas de temperatura
const int Temp_DOUT_PIN1 = 18;
const int Temp_SCK_PIN1 = 5;
const int Temp_DOUT_PIN2 = 19;
const int Temp_SCK_PIN2 = 4;

//variaveis para o teste das saidas analogicas
const int ledChannel1 = 0, ledChannel2 = 1;

int dutyCycle1 = 0, dutyCycle2 = 0;

int estado1 = 0;
int saida1 = 0;
unsigned long analog_tmr1 = 0;

long analog_raw1 = 0;
float analog1 = 0;

long analog_raw2 = 0;
float analog2 = 0;

int estado2 = 0;
int saida2 = 0;
unsigned long analog_tmr2 = 0;


int control = 0;
bool input4 = 0;


unsigned long temp_tmr1 = 0;
long Raw_temp1 = 0;
float temp1 = 0;

unsigned long temp_tmr2 = 0;
long Raw_temp2 = 0;
float temp2 = 0;

unsigned long TMR_Loop = 0;
String inputString485 = "";         // a String to hold incoming data
bool stringComplete485 = false;  // whether the string is complete
String inputStringTTL = "";         // a String to hold incoming data
bool stringCompleteTTL = false;  // whether the string is complete

//chamada da biblioteca
HX711_ADC Sensor1(Temp_DOUT_PIN1, Temp_SCK_PIN1);
HX711_ADC Sensor2(Temp_DOUT_PIN2, Temp_SCK_PIN2);

#include "Digitais.h"
#include "Analogicas.h"
#include "Temperatura.h"
#include "Serial485.h"
#include "SerialTTL.h"

void setup() {
  Serial.begin(115200);//USB
  Serial1.begin(115200, SERIAL_8N1, 22, 21); // (TTL)
  Serial2.begin(115200); //(485)

  //Configura variável da comunicação
  inputString485.reserve(200);
  inputStringTTL.reserve(200);

  //definições função PWM para as sídas analógicas
  ledcSetup(ledChannel1, 1000, 12);
  ledcAttachPin(AO1, ledChannel1);
  
  ledcSetup(ledChannel2, 1000, 12);
  ledcAttachPin(AO2, ledChannel2);
  
  //Inicializa hardware
  pinMode(pin_X1, INPUT);
  pinMode(pin_X2, INPUT);
  pinMode(pin_X3, INPUT);
  //A leitura do X4 é feita como analógica

  pinMode(pin_Y1, OUTPUT);
  pinMode(pin_Y2, OUTPUT);
  pinMode(pin_Y3, OUTPUT);
  pinMode(pin_Y4, OUTPUT);
  pinMode(pin_Y5, OUTPUT);
  pinMode(pin_Y6, OUTPUT);

  //incio da biblioteca HX711
  Sensor1.begin();
  Sensor1.start(2000, false);
  Sensor1.setCalFactor(1);

  Sensor2.begin();
  Sensor2.start(2000, false);
  Sensor2.setCalFactor(1);
}

void loop() {
  if (millis() > (TMR_Loop + 200)){
    digitais();
    analogicas();
    temp();
    TMR_Loop = millis();
  }
  Serial485();
  SerialTTL();
}
